plugins['clock'] = (function() {

    return { 

        loadLang: function(values) {
            var hash = hex_md5(secret+lastkey);
            queuedcommand = "<msg data=\"" + myposition + "|pluginlang|" + language + "~clock" + "|" + hash + "\" />";
            sendcommand();
        },

        setLang: function() {
            // This method is used to apply a language strings to html elements
        },

        updateClock: function() {

            var currentTime = new Date ( );

            var currentHours = currentTime.getHours ( );
            var currentMinutes = currentTime.getMinutes ( );
            var currentSeconds = currentTime.getSeconds ( );

            // Pad the minutes and seconds with leading zeros, if required
            currentMinutes = ( currentMinutes < 10 ? "0" : "" ) + currentMinutes;
            currentSeconds = ( currentSeconds < 10 ? "0" : "" ) + currentSeconds;

            var timeOfDay = '';

            if(pluginconfig['clock']['24_hs_format']['']==0) {
                timeOfDay = ( currentHours < 12 ) ? "AM" : "PM";
                currentHours = ( currentHours > 12 ) ? currentHours - 12 : currentHours;
            }

            // Convert an hours component of "0" to "12"
            currentHours = ( currentHours == 0 ) ? 12 : currentHours;
            paddedHours = currentHours.toString().padStart(2, '0');

            // Compose the string for display
            var currentTimeString = currentHours + ":" + currentMinutes + ":" + currentSeconds + " " + timeOfDay;

            // Update the time display
            document.getElementById("dc").innerHTML=paddedHours+"<span id='csep'>:</span>"+currentMinutes;
            document.getElementById("dc_second").innerHTML=currentSeconds;
            document.getElementById("dc_hour").innerHTML=timeOfDay;
            document.getElementById('csep').style.visibility='';
            setTimeout(function() { document.getElementById('csep').style.visibility = 'hidden'; },500);

        },
        callback_zbuttons: function() {
            debug('clock zbuttons');
            window.clearInterval(window.clocktimer);
            window.clocktimer = window.setInterval(function(){
                plugins['clock'].updateClock();
            }, 1000);
            var largo1 = $('#actionbar').find(':visible').length;
            var largo2 = $('#custombar').find(':visible').length;
            var hayvisibles = largo1 + largo2;
            if(hayvisibles == 0) {
                if(parseInt(currentrelease.replace(/\./g,''))<23137) {
                    // hacemos un pull de el filter dial porque  no hay acciones
                    $('#dialfilterbar').removeClass('col-md-pull-5');
                    $('#dialfilterbar').removeClass('col-lg-pull-5');
                    $('#dialfilterbar').addClass('col-md-pull-4');
                    $('#dialfilterbar').addClass('col-lg-pull-4');
                }
            } 

        },
        init: function() {

            if($('.clockcontainer').length==0) {
                $("head").append("<link href='https://fonts.googleapis.com/css?family=Orbitron' rel='stylesheet' type='text/css'>");
                if($('#secondtoolbar').length>0) {
                    // pre 2.30 version
                    $( "#secondtoolbar" ).before( "<span id='clock'>&nbsp;</span>" );
                } else {
                    // post 2.30 version
                    $( "#custombar" ).after("<div class='clockcontainer'><table class='tabBlock'><tr><td class='clock' id='dc'></td><td id='campm'><table><tr class='clocktrh'><td class='clocklg' id='dc_hour'></td></tr><tr class='clocktrh'><td class='clocklg' id='dc_second'></td></tr></table></td></tr></table></div>");

                    if(pluginconfig['clock']['24_hs_format']['']==1) {
                        $('#campm').hide();
                    } else {
                        $('#campm').show();
                    }
                }
            } else {
                if($('#campm').length>0) {
                    if(pluginconfig['clock']['24_hs_format']['']==1) {
                        $('#campm').hide();
                    } else {
                        $('#campm').show();
                    }
                }
            }
        }
    }
}());
